Name:           flintqs
Version:        1.0
Release:        1%{?dist}
Summary:        William Hart's quadratic sieve

License:        GPLv2+
URL:            https://github.com/sagemath/FlintQS
Source0:        %{url}/archive/v%{version}/%{name}-%{version}.tar.gz
# Use of the register storage class is deprecated
# https://github.com/sagemath/FlintQS/pull/2
Patch0:         %{name}-register.patch
# Add "const" keywords to silence writable string warnings
# https://github.com/sagemath/FlintQS/pull/2
Patch1:         %{name}-writable-string.patch
# Fix mixed signed/unsigned operations
# https://github.com/sagemath/FlintQS/pull/2
Patch2:         %{name}-signed.patch
# Remove an unused variable
# https://github.com/sagemath/FlintQS/pull/2
Patch3:         %{name}-unused.patch
# Account for possibly unset TMPDIR environment variable
Patch4:         %{name}-tmpdir.patch
# Plug memory leaks
# https://github.com/sagemath/FlintQS/pull/1
Patch5:         %{name}-memleak.patch

BuildRequires:  autoconf
BuildRequires:  automake
BuildRequires:  gcc-c++
BuildRequires:  gmp-devel
BuildRequires:  libtool

%description
This package contains William Hart's quadratic sieve implementation,
as modified for sagemath.

%prep
%autosetup -n FlintQS-%{version} -p1

# There is no m4 directory
sed -i '/m4/d' configure.ac

# Generate the configure script
AUTOMAKE="automake --foreign" autoreconf -fi .

%build
%configure
%make_build

%install
%make_install

%check
# Example from
# https://doc.sagemath.org/html/en/reference/interfaces/sage/interfaces/qsieve.html
factors="$(
  echo '1000000000000000005490000000000000001989' |
  %{buildroot}%{_bindir}/QuadraticSieve |
  awk 'f; /^FACTORS:$/ {f=1}' | sort -n -u | tr '\n' ' '
)"
[ "${factors}" = '10000000000000000051 100000000000000000039 ' ]

%files
%doc AUTHORS NEWS README
%license COPYING
%{_bindir}/QuadraticSieve

%changelog
* Wed Aug 11 2021 Jerry James <loganjerry@gmail.com> - 1.0-1
- Initial RPM
